//  ---------------------------------------------------------------------------
//	SUP64.h	̧ͯ			SPU64.dllgpع݌
//	
//	쐬	2011/07/26			M.YOSHIDA
//	
//  SUP : Smart-USB Plus
//        ^     ^   ^
//	
//	ނ"4"ɐݒ肵Ă
//  ---------------------------------------------------------------------------
#ifndef	SUP64_H
#define SUP64_H

#include	<winusb.h>
#include	<usb100.h>

//  ---------------------------------------------------------------------------
//  \̐錾


//	INF̧قŎw肵Smart-USB Plus޲̲̪GUID
static const GUID SUP64_DEVICE_INTERFACE = { 0x82EFB874, 0x53F7, 0x4595, { 0x9B, 0x80, 0x53, 0x88, 0x38, 0x0A, 0x1B, 0x3A }};


typedef unsigned __int64	UINT64;

//  ---------------------------------------------------------------------------
//	ʒ萔
//  ---------------------------------------------------------------------------
#define		true								1
#define		false								0

#define		SUP64_DBT_VIDNAME					"VID_0A2F"

#define		USB_MAXDEVICE						127

#define     SUP64_RANGE_8BIT                  	0x00        //  8ޯ
#define     SUP64_RANGE_16BIT                 	0x40        //  16ޯ
#define     SUP64_RANGE_32BIT                 	0x80        //  32ޯ
#define     SUP64_RANGE_64BIT                 	0xC0        //  64ޯ

#define     SUP64_ADRS_MASK                   	0x003F
#define     SUP64_RANGE_MASK                	0x00C0

#define		SUP64_MEMDIR_READ					0
#define		SUP64_MEMDIR_WRITE					1

#define		SUP64_MAX_TRANSFER_SIZE				2097152

#define		SUP64_XOR_PARAM						0xAAAAAAAA

//  ʐM
#define     SUP64_DIRECTION_DEVICE_TO_HOST		0xC0        //  ޲  ν
#define     SUP64_DIRECTION_HOST_TO_DEVICE		0x40        //  ν  ޲

//  ظ
#define     SUP64_REQUEST_CLASS					0x01        //  1 : ׽ظ
#define     SUP64_REQUEST_VENDER              	0x02        //  2 : ظ

//  ޯđI
#define     SUP64_RECEPIENT_DEVICE            	0x00        //  ޲
#define     SUP64_RECEPIENT_INTERFACE			0x01        //  ̪
#define     SUP64_RECEPIENT_ENDPOINT          	0x02        //  ߲
#define     SUP64_RECEPIENT_OTHER             	0x03        //  ̑

//	߲ıڽ
#define		SUP64_WRITE_EP_ADRS					0x06
#define		SUP64_READ_EP_ADRS					0x82

//  ظĺ
#define     SUP64_VENDER_REQUEST_REGISTER     	0xB0
#define     SUP64_VENDER_REQUEST_DATA         	0xB1
#define     SUP64_VENDER_REQUEST_USBCONFIG    	0xB2
#define     SUP64_VENDER_REQUEST_BOARDINFO    	0xB3
#define     SUP64_VENDER_REQUEST_GPIODIR      	0xB4
#define     SUP64_VENDER_REQUEST_GPIOWRITE    	0xB5
#define     SUP64_VENDER_REQUEST_GPIOREAD     	0xB6
#define     SUP64_VENDER_REQUEST_GPIFWAIT     	0xB7
#define     SUP64_VENDER_REQUEST_GPIFWAVE     	0xB8
#define     SUP64_VENDER_REQUEST_GPIFCLK      	0xB9
#define     SUP64_VENDER_REQUEST_GPIFFLAG     	0xBA
#define     SUP64_VENDER_REQUEST_8051CORE     	0xBB
#define     SUP64_VENDER_REQUEST_I2CWRITE     	0xC0
#define     SUP64_VENDER_REQUEST_I2CREAD      	0xC1
#define     SUP64_VENDER_REQUEST_GETTEMP      	0xC2
#define     SUP64_VENDER_REQUEST_WAVECHANGE    	0xC3
#define     SUP64_VENDER_REQUEST_SUSPEND      	0xC4

//  USB̨޺޺
#define     SUP64_USBCONFIG_START             	0xC1
#define     SUP64_USBCONFIG_END               	0x41
#define     SUP64_DONE_WAIT_SIZE              	65536
#define     SUP64_CFG_STS_ADRS				    2
#define     SUP64_CFG_STATUS_SUCCESS			0
#define		SUP64_CFG_MODE_REG_ADRS				63
#define		SUP64_CFG_MODE_INT					0x00
#define		SUP64_CFG_MODE_EXT					0x01

//  ް]޺
#define     SUP64_DATA_TRANS_OUT_START        	0xC0
#define     SUP64_DATA_TRANS_OUT_END          	0x40
#define     SUP64_DATA_TRANS_IN_START         	0x80
#define     SUP64_DATA_TRANS_IN_END           	0x00

#define     SUP64_CONFIG_MODE_ALTERA          	0
#define     SUP64_CONFIG_MODE_XILINX          	1

//  ظ(B3h) ްޏ擾ނ̎擾I
#define     SUP64_BOARDINFO_FIRMID            	0x00C0
#define     SUP64_BOARDINFO_CHIPVER           	0x0080
#define     SUP64_BOARDINFO_PID               	0x0040
#define     SUP64_BOARDINFO_SPEED             	0x0000
#define     SUP64_FULL_SPEED                  	0x0000
#define     SUP64_HIGH_SPEED                  	0x0001

//  GPIO֌W
#define     SUP64_GPIO_PORTA                  	0x0000
#define     SUP64_GPIO_PORTC                  	0x0001
#define     SUP64_GPIO_PORTE                  	0x0002
#define     SUP64_GPIO_DIRIN                  	0x0000
#define     SUP64_GPIO_DIROUT                 	0x0001

//
#define     SUP64_GPIF_WAIT_REGREAD           	0x0000
#define     SUP64_GPIF_WAIT_REGWRITE          	0x0001

//  GPIFۯݒpҰ
#define     SUP64_GPIFCLK_SOURCE              	0x0000
#define     SUP64_GPIFCLK_SPEED               	0x0001

#define     SUP64_GPIFCLK_INTERNAL            	0x0000
#define     SUP64_GPIFCLK_EXTERNAL            	0x0001

#define     SUP64_GPIFCLK_48MHZ               	0x0000
#define     SUP64_GPIFCLK_30MHZ               	0x0001

//  8051ݒpҰ
#define     SUP64_8051_CLKOUT                 	0x0000
#define     SUP64_8051_SPEED                  	0x0001

#define     SUP64_8051_CLKDISABLE             	0x0000
#define     SUP64_8051_CLKENABLE              	0x0001

#define     SUP64_8051_CLK12MHZ               	0x0000
#define     SUP64_8051_CLK24MHZ               	0x0001
#define     SUP64_8051_CLK48MHZ               	0x0002


//	GPIFؓ]ӰޗpҰ
#define		SUP64_GPIFWAVE_DIR_READ				0x0000
#define		SUP64_GPIFWAVE_DIR_WRITE			0x0001
#define		SUP64_GPIFWAVE_MODE_BURST			0x0000
#define		SUP64_GPIFWAVE_MODE_WORD			0x0001

//  ---------------------------------------------------------------------------
//	֐ߐ錾
//  ---------------------------------------------------------------------------

//  /۰ފ֐
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Usb_Open( GUID guidDeviceInterface, PWINUSB_INTERFACE_HANDLE phWinUSBHandle );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Usb_Close( WINUSB_INTERFACE_HANDLE hWinUSBHandle );


//	/۰ފ֐(Ver 1.0.3.0Œǉ)
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Get_Device_Handle( GUID guidDeviceInterface, DWORD *num, HANDLE *FoundHandle );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Usb_Open_Handle( HANDLE FoundHandle, PWINUSB_INTERFACE_HANDLE phWinUSBHandle );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Usb_OpenEx( GUID guidDeviceInterface, HANDLE *FoundHandle, PWINUSB_INTERFACE_HANDLE phWinUSBHandle );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Usb_CloseEx( HANDLE FoundHandle, WINUSB_INTERFACE_HANDLE hWinUSBHandle );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Find_Device( GUID guidDeviceInterface, DWORD adrs, DWORD id, HANDLE *FoundHandle );
//	܂Ver 1.0.3.0ł̒ǉ

//  ްذ/ײĊ֐
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Data_Write( WINUSB_INTERFACE_HANDLE hWinUSBHandle, BYTE range, DWORD FileSize, LPVOID pBuffer );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Data_Read( WINUSB_INTERFACE_HANDLE hWinUSBHandle, BYTE range, DWORD FileSize, LPVOID pBuffer );

//  ڼ޽֐
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Reg_Write( WINUSB_INTERFACE_HANDLE hWinUSBHandle, DWORD adrs, DWORD range, UINT64 wd );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Reg_Read( WINUSB_INTERFACE_HANDLE hWinUSBHandle, DWORD adrs, DWORD range, UINT64 *rd );

extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Reg_WriteEx( WINUSB_INTERFACE_HANDLE hWinUSBHandle, DWORD adrs, DWORD size, BYTE *wd );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Reg_ReadEx( WINUSB_INTERFACE_HANDLE hWinUSBHandle, DWORD adrs, DWORD size, BYTE *rd );

//  հèè֐
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Get_BoardInfo( WINUSB_INTERFACE_HANDLE hWinUSBHandle, DWORD Sel, DWORD *ID );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Usb_Config( WINUSB_INTERFACE_HANDLE hWinUSBHandle, TCHAR *PathName, bool Mode, bool Swap, bool Encrypt );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_I2c_Read( WINUSB_INTERFACE_HANDLE hWinUSBHandle, DWORD DevAdrs, DWORD RegAdrs, BYTE *Rd );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_I2c_Write( WINUSB_INTERFACE_HANDLE hWinUSBHandle, DWORD DevAdrs, DWORD RegAdrs, BYTE Wd );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Get_FPGA_Temp( WINUSB_INTERFACE_HANDLE hWinUSBHandle, WORD Sel, WORD *Temp );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_Suspend( WINUSB_INTERFACE_HANDLE hWinUSBHandle, WORD mode );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_GPIO_Dir( WINUSB_INTERFACE_HANDLE hWinUSBHandle, WORD port, WORD dir );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_GPIO_Read( WINUSB_INTERFACE_HANDLE hWinUSBHandle, WORD port, BYTE *Rd );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_GPIO_Write( WINUSB_INTERFACE_HANDLE hWinUSBHandle, WORD port, BYTE Wd );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_GPIF_Set_Wave( WINUSB_INTERFACE_HANDLE hWinUSBHandle, WORD dir, WORD sel );
extern "C" __declspec( dllimport ) BOOL		__stdcall	SUP64_GPIF_Reg_Wait( WINUSB_INTERFACE_HANDLE hWinUSBHandle, WORD dir, BYTE num );






#endif
