//---------------------------------------------------------------------------
//	BitSwap.h ̧ͯ
//
//	쐬	2011N0825		M.YOSHIDA
//
//	ނ"4"ɐݒ肵Ă
//
//---------------------------------------------------------------------------
#ifndef	BITSWAP_H
#define	BITSWAP_H

const	BYTE	SWAP[256] = {	0x00,    // 0x00
								0x80,    // 0x01
								0x40,    // 0x02
								0xC0,    // 0x03
								0x20,    // 0x04
								0xA0,    // 0x05
								0x60,    // 0x06
								0xE0,    // 0x07
								0x10,    // 0x08
								0x90,    // 0x09
								0x50,    // 0x0A
								0xD0,    // 0x0B
								0x30,    // 0x0C
								0xB0,    // 0x0D
								0x70,    // 0x0E
								0xF0,    // 0x0F
								0x08,    // 0x10
								0x88,    // 0x11
								0x48,    // 0x12
								0xC8,    // 0x13
								0x28,    // 0x14
								0xA8,    // 0x15
								0x68,    // 0x16
								0xE8,    // 0x17
								0x18,    // 0x18
								0x98,    // 0x19
								0x58,    // 0x1A
								0xD8,    // 0x1B
								0x38,    // 0x1C
								0xB8,    // 0x1D
								0x78,    // 0x1E
								0xF8,    // 0x1F
								0x04,    // 0x20
								0x84,    // 0x21
								0x44,    // 0x22
								0xC4,    // 0x23
								0x24,    // 0x24
								0xA4,    // 0x25
								0x64,    // 0x26
								0xE4,    // 0x27
								0x14,    // 0x28
								0x94,    // 0x29
								0x54,    // 0x2A
								0xD4,    // 0x2B
								0x34,    // 0x2C
								0xB4,    // 0x2D
								0x74,    // 0x2E
								0xF4,    // 0x2F
								0x0C,    // 0x30
								0x8C,    // 0x31
								0x4C,    // 0x32
								0xCC,    // 0x33
								0x2C,    // 0x34
								0xAC,    // 0x35
								0x6C,    // 0x36
								0xEC,    // 0x37
								0x1C,    // 0x38
								0x9C,    // 0x39
								0x5C,    // 0x3A
								0xDC,    // 0x3B
								0x3C,    // 0x3C
								0xBC,    // 0x3D
								0x7C,    // 0x3E
								0xFC,    // 0x3F
								0x02,    // 0x40
								0x82,    // 0x41
								0x42,    // 0x42
								0xC2,    // 0x43
								0x22,    // 0x44
								0xA2,    // 0x45
								0x62,    // 0x46
								0xE2,    // 0x47
								0x12,    // 0x48
								0x92,    // 0x49
								0x52,    // 0x4A
								0xD2,    // 0x4B
								0x32,    // 0x4C
								0xB2,    // 0x4D
								0x72,    // 0x4E
								0xF2,    // 0x4F
								0x0A,    // 0x50
								0x8A,    // 0x51
								0x4A,    // 0x52
								0xCA,    // 0x53
								0x2A,    // 0x54
								0xAA,    // 0x55
								0x6A,    // 0x56
								0xEA,    // 0x57
								0x1A,    // 0x58
								0x9A,    // 0x59
								0x5A,    // 0x5A
								0xDA,    // 0x5B
								0x3A,    // 0x5C
								0xBA,    // 0x5D
								0x7A,    // 0x5E
								0xFA,    // 0x5F
								0x06,    // 0x60
								0x86,    // 0x61
								0x46,    // 0x62
								0xC6,    // 0x63
								0x26,    // 0x64
								0xA6,    // 0x65
								0x66,    // 0x66
								0xE6,    // 0x67
								0x16,    // 0x68
								0x96,    // 0x69
								0x56,    // 0x6A
								0xD6,    // 0x6B
								0x36,    // 0x6C
								0xB6,    // 0x6D
								0x76,    // 0x6E
								0xF6,    // 0x6F
								0x0E,    // 0x70
								0x8E,    // 0x71
								0x4E,    // 0x72
								0xCE,    // 0x73
								0x2E,    // 0x74
								0xAE,    // 0x75
								0x6E,    // 0x76
								0xEE,    // 0x77
								0x1E,    // 0x78
								0x9E,    // 0x79
								0x5E,    // 0x7A
								0xDE,    // 0x7B
								0x3E,    // 0x7C
								0xBE,    // 0x7D
								0x7E,    // 0x7E
								0xFE,    // 0x7F
								0x01,    // 0x80
								0x81,    // 0x81
								0x41,    // 0x82
								0xC1,    // 0x83
								0x21,    // 0x84
								0xA1,    // 0x85
								0x61,    // 0x86
								0xE1,    // 0x87
								0x11,    // 0x88
								0x91,    // 0x89
								0x51,    // 0x8A
								0xD1,    // 0x8B
								0x31,    // 0x8C
								0xB1,    // 0x8D
								0x71,    // 0x8E
								0xF1,    // 0x8F
								0x09,    // 0x90
								0x89,    // 0x91
								0x49,    // 0x92
								0xC9,    // 0x93
								0x29,    // 0x94
								0xA9,    // 0x95
								0x69,    // 0x96
								0xE9,    // 0x97
								0x19,    // 0x98
								0x99,    // 0x99
								0x59,    // 0x9A
								0xD9,    // 0x9B
								0x39,    // 0x9C
								0xB9,    // 0x9D
								0x79,    // 0x9E
								0xF9,    // 0x9F
								0x05,    // 0xA0
								0x85,    // 0xA1
								0x45,    // 0xA2
								0xC5,    // 0xA3
								0x25,    // 0xA4
								0xA5,    // 0xA5
								0x65,    // 0xA6
								0xE5,    // 0xA7
								0x15,    // 0xA8
								0x95,    // 0xA9
								0x55,    // 0xAA
								0xD5,    // 0xAB
								0x35,    // 0xAC
								0xB5,    // 0xAD
								0x75,    // 0xAE
								0xF5,    // 0xAF
								0x0D,    // 0xB0
								0x8D,    // 0xB1
								0x4D,    // 0xB2
								0xCD,    // 0xB3
								0x2D,    // 0xB4
								0xAD,    // 0xB5
								0x6D,    // 0xB6
								0xED,    // 0xB7
								0x1D,    // 0xB8
								0x9D,    // 0xB9
								0x5D,    // 0xBA
								0xDD,    // 0xBB
								0x3D,    // 0xBC
								0xBD,    // 0xBD
								0x7D,    // 0xBE
								0xFD,    // 0xBF
								0x03,    // 0xC0
								0x83,    // 0xC1
								0x43,    // 0xC2
								0xC3,    // 0xC3
								0x23,    // 0xC4
								0xA3,    // 0xC5
								0x63,    // 0xC6
								0xE3,    // 0xC7
								0x13,    // 0xC8
								0x93,    // 0xC9
								0x53,    // 0xCA
								0xD3,    // 0xCB
								0x33,    // 0xCC
								0xB3,    // 0xCD
								0x73,    // 0xCE
								0xF3,    // 0xCF
								0x0B,    // 0xD0
								0x8B,    // 0xD1
								0x4B,    // 0xD2
								0xCB,    // 0xD3
								0x2B,    // 0xD4
								0xAB,    // 0xD5
								0x6B,    // 0xD6
								0xEB,    // 0xD7
								0x1B,    // 0xD8
								0x9B,    // 0xD9
								0x5B,    // 0xDA
								0xDB,    // 0xDB
								0x3B,    // 0xDC
								0xBB,    // 0xDD
								0x7B,    // 0xDE
								0xFB,    // 0xDF
								0x07,    // 0xE0
								0x87,    // 0xE1
								0x47,    // 0xE2
								0xC7,    // 0xE3
								0x27,    // 0xE4
								0xA7,    // 0xE5
								0x67,    // 0xE6
								0xE7,    // 0xE7
								0x17,    // 0xE8
								0x97,    // 0xE9
								0x57,    // 0xEA
								0xD7,    // 0xEB
								0x37,    // 0xEC
								0xB7,    // 0xED
								0x77,    // 0xEE
								0xF7,    // 0xEF
								0x0F,    // 0xF0
								0x8F,    // 0xF1
								0x4F,    // 0xF2
								0xCF,    // 0xF3
								0x2F,    // 0xF4
								0xAF,    // 0xF5
								0x6F,    // 0xF6
								0xEF,    // 0xF7
								0x1F,    // 0xF8
								0x9F,    // 0xF9
								0x5F,    // 0xFA
								0xDF,    // 0xFB
								0x3F,    // 0xFC
								0xBF,    // 0xFD
								0x7F,    // 0xFE
								0xFF     // 0xFF
							};

#endif
