// SUP64_Test.cpp : R\[ AvP[ṼGg |Cg`܂
//

#include	"stdafx.h"
#include	"SUP64.h"


#pragma comment(lib, "SUP64.lib" )
#pragma comment(lib, "winmm.lib")

#define		USB_CONFIG		0
#define		MEMW_TEST		0
#define		MEMR_TEST		0
#define		REG_TEST		0
#define		I2C_TEST		0
#define		TEMP_TEST		0
#define		SUSPEND_TEST	0
#define		GPIO_TEST		0
#define		WAVE_TEST		0
#define		REGEX_TEST		0
#define		REGWAIT_TEST	0

int _tmain(int argc, _TCHAR* argv[])
{
//    WINUSB_INTERFACE_HANDLE hWinUSBHandle = INVALID_HANDLE_VALUE;
	GUID		guidDeviceInterface = SUP64_DEVICE_INTERFACE;
	DWORD		id;
	DWORD		StTime;
	DWORD		EdTime;
	UINT64		Wd;
	UINT64		Rd = 0;
	DWORD		i, j;

	TCHAR		FilePath[MAX_PATH] = L".\\bin\\Random1_4MB.bin";
	HANDLE		hFile;
	DWORD		FSize;
	DWORD		ReadNum = 0x400000;
	DWORD		WriteNum = 0x400000;
	HANDLE		fp = NULL;
	LPVOID		pBuffer;
	DWORD		rb;


	#if I2C_TEST

	DWORD		k, l;
	BYTE		I2c_Wd, I2c_Rd;
	BYTE		wdump[128];
	BYTE		rdump[128];

	#endif

	#if TEMP_TEST

	DWORD		n;
	WORD		Temp;

	#endif

	#if GPIO_TEST

	DWORD		m;
	BYTE		GPIO_Rd;

	#endif

	#if REGEX_TEST

	BYTE		wd[64];
	BYTE		rd[64];

	#endif


	BYTE		wd[64];



	DWORD		num;
    HANDLE		FoundHandle[USB_MAXDEVICE];
//    WINUSB_INTERFACE_HANDLE hWinUSBHandle[USB_MAXDEVICE];


	_tprintf( _T("\nSUP64.dll TEST PROGRAM.\n"));
	_tprintf( _T("SUP64_Test Version 1.03(BETA)    Copyright(C) 2004-2013, Prime Systems, Inc.\n"));
	_tprintf( _T("Compile time %s %s\n\n"), _T(__DATE__), _T(__TIME__));


#if 0
	//	SUP64޲݂ق擾
	if( !SUP64_Usb_Open( guidDeviceInterface, &hWinUSBHandle ))
	{
		_tprintf( _T("SUP64 device not found!!\n"));
		return	false;
	}

	//	ްޏ̎擾
	if( !SUP64_Get_BoardInfo( hWinUSBHandle, SUP64_BOARDINFO_PID, &id ))
	{
		SUP64_Usb_Close( hWinUSBHandle );
		_tprintf( _T("SUP64_Get_BoardInfo() failed!!\n\n"));
		return	false;
	}
	_tprintf( _T("PID:%04X SUP64 Device Found!!\n\n"), id );
#endif


#if 0
	//	Ver1.0.3.0Œǉ޲API̻
	//	ُ
	for(i=0;i<USB_MAXDEVICE;++i)
	{
		FoundHandle[i] = INVALID_HANDLE_VALUE;
		hWinUSBHandle[i] = INVALID_HANDLE_VALUE;
	}

	//	޲
	if( !SUP64_Get_Device_Handle( guidDeviceInterface, &num, &FoundHandle[0] ))
	{
		_tprintf( _T("SUP64_Get_Device_Handle() NG!!\n"));
		return	false;
	}

	_tprintf( _T("%d DEVICE FOUND!!\n"), num );

	for(i=0;i<num;++i)
	{
		if( !SUP64_Usb_Open_Handle( FoundHandle[i], &hWinUSBHandle[i] ))
		{
			_tprintf( _T("%d Device : SUP64_Usb_Open_Handle() NG!!\n"), i );
			return	false;
		}
		else
		{
			//	݂޲ްޏ擾
			if( !SUP64_Get_BoardInfo( hWinUSBHandle[i], SUP64_BOARDINFO_PID, &id ))
			{
				SUP64_Usb_Close( hWinUSBHandle[i] );
				_tprintf( _T("SUP64_Get_BoardInfo() failed!!\n\n"));
				return	false;
			}
			_tprintf( _T("%d Device - PID:%04X SUP64 Device Found!!\n"), i, id );
			SUP64_Usb_Close( hWinUSBHandle[i] );
		}
	}
#endif

#if	0
	//	Ver1.0.3.0ŒǉVOPEN/CLOSE API̻
	//	̻ق1̂

    WINUSB_INTERFACE_HANDLE hWinUSBHandle;
	HANDLE	hFoundHandle;

	//	ýėp10JԂ
	for(i=0;i<10;++i)
	{
		//	SUP64޲݂ق擾
		if( !SUP64_Usb_OpenEx( guidDeviceInterface, &hFoundHandle, &hWinUSBHandle ))
		{
			_tprintf( _T("SUP64 device not found!!\n"));
			return	false;
		}

		//	ްޏ̎擾
		if( !SUP64_Get_BoardInfo( hWinUSBHandle, SUP64_BOARDINFO_PID, &id ))
		{
			SUP64_Usb_CloseEx( hFoundHandle, hWinUSBHandle );
			_tprintf( _T("SUP64_Get_BoardInfo() failed!!\n\n"));
			return	false;
		}
		_tprintf( _T("PID:%04X SUP64 Device Found!!\n"), id );
		SUP64_Usb_CloseEx( hFoundHandle, hWinUSBHandle );

		//	۰ތɍēx݂
		if( !SUP64_Usb_OpenEx( guidDeviceInterface, &hFoundHandle, &hWinUSBHandle ))
		{
			_tprintf( _T("SUP64 device not found!!\n"));
			return	false;
		}

		//	ްޏ̎擾
		if( !SUP64_Get_BoardInfo( hWinUSBHandle, SUP64_BOARDINFO_PID, &id ))
		{
			SUP64_Usb_CloseEx( hFoundHandle, hWinUSBHandle );
			_tprintf( _T("SUP64_Get_BoardInfo() failed!!\n\n"));
			return	false;
		}
		_tprintf( _T("PID:%04X SUP64 Device Found!!\n\n"), id );

		SUP64_Usb_CloseEx( hFoundHandle, hWinUSBHandle );
	}

#endif


#if	1

	//	Ver1.0.3.0ŒǉSUP64_Find_Device()̻
	//	ޯڼ޽́u3v
	//	ID́u6vƂ

	HANDLE	hFoundHandle;
    WINUSB_INTERFACE_HANDLE hWinUSBHandle;

	if( !SUP64_Find_Device( guidDeviceInterface, 3, 6, &hFoundHandle ))
	{
		_tprintf( _T("DEVICE not found!!\n\n"));
	}
	else
	{
		//	޲݂ڼ޽2ײĂB
		if( !SUP64_Usb_Open_Handle( hFoundHandle, &hWinUSBHandle ))
		{
			_tprintf( _T("SUP64_Usb_Open_Handle() failed!!\n\n"));

			//	݂łȂꍇłق̸۰ނYȂlɁB
			CloseHandle( hFoundHandle );
		}
		else
		{
			if( !SUP64_Reg_Write( hWinUSBHandle, 2, SUP64_RANGE_8BIT, 0xAA ))
			{
				//	ײĎs
				_tprintf( _T("WRITE Failed!!\n"));
				SUP64_Usb_CloseEx( hFoundHandle, hWinUSBHandle );
				return false;
			}
			else
			{
				_tprintf( _T("SUP64_Find_Device() Successfully!!\n"));
			}

			//	USB޲ق۰ނ
			SUP64_Usb_CloseEx( hFoundHandle, hWinUSBHandle );
		}
	}




#endif

#if USB_CONFIG
	//	USB̨ގs
	_tprintf( _T("Configure ........ "));
	StTime = timeGetTime();							//	̎Ԃ̨ގԂƂB
//	if( SUP64_Usb_Config( hWinUSBHandle, _T(".\\rbf\\GPIF_Verilog_SX-USB2_EP2S15.rbf"), SUP64_CONFIG_MODE_ALTERA ))
	if( SUP64_Usb_Config( hWinUSBHandle, _T(".\\rbf\\SX-Card6_LX75_LED.bin"), SUP64_CONFIG_MODE_XILINX, true, false ))
//	if( SUP64_Usb_Config( hWinUSBHandle, _T(".\\rbf\\SX-Card6_LX75_Encrypt.bin"), SUP64_CONFIG_MODE_XILINX, true, true ))
	{
		//	̨ސ
		_tprintf( _T(" Successfully!!\n"));
	
		//	oߎԂ̕\
		EdTime = timeGetTime();
		_tprintf( _T("Configure Time = %ldms\n"), EdTime - StTime );
	}
	else
	{
		//	̨ގs
		_tprintf( _T(" Failed!!\n"));
	}
	_tprintf( _T(" \n"));
	#endif

	#if MEMW_TEST
	//	-----------------------------------------------------------------------
	//	ײď
	//	ް̧ق̗LmF
	hFile = CreateFile( FilePath, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	if( hFile == INVALID_HANDLE_VALUE )
	{
		//	Ώ̧ٖ
		SUP64_Usb_Close( hWinUSBHandle );
		_tprintf( _T("Cannot found [%s]\n\n"), FilePath );
		return false;
	}
	else
	{
		//	̧ٻފmF
		FSize = GetFileSize( hFile, NULL );
		if( FSize == -1 )
		{
			//	̧ٻގ擾s	
			SUP64_Usb_Close( hWinUSBHandle );
			CloseHandle( hFile );
			_tprintf( _T("File Size ERROR!!\n"));
			return false;
		}
		CloseHandle( hFile );

		//	̧ٻނwݸ޽ꍇɂ͏IB
		if( WriteNum > FSize )
		{
			SUP64_Usb_Close( hWinUSBHandle );
			_tprintf( _T("Transfer Size ERROR!!(TransferSize > FileSize)\n"));
			return false;
		}

		//	]ނ̕\
		_tprintf( _T("MW Transfer Size %ldBytes\n"), WriteNum );

		//	̧ٵ
	    fp = CreateFile( FilePath, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL );
	    if( fp == NULL || fp == INVALID_HANDLE_VALUE )
	    {
			SUP64_Usb_Close( hWinUSBHandle );
			_tprintf( _T("File Open ERROR!!\n"));
	        return false;
	    }
		else
		{
	        pBuffer = GlobalAlloc( GPTR, WriteNum );
			if( pBuffer == NULL )
			{
		        CloseHandle( fp );
				SUP64_Usb_Close( hWinUSBHandle );
				_tprintf( _T("Memory Alloc ERROR!!\n"));
				return false;
			}

	        ReadFile( fp, pBuffer, WriteNum, &rb, NULL );
	        CloseHandle( fp );

			//	ǂݍݻފmF
			if( WriteNum != rb )
			{
				GlobalFree( pBuffer );
				SUP64_Usb_Close( hWinUSBHandle );
				_tprintf( _T("File Read ERROR!!\n"));
				return false;
			}

			//	ް]
			_tprintf( _T("MemWriting ........ "));
			StTime = timeGetTime();						//	̎Ԃް]ԂƂ
			if( !SUP64_Data_Write( hWinUSBHandle, SUP64_RANGE_8BIT, WriteNum, pBuffer ))
			{
				//	ްײĎs
				_tprintf( _T(" Failed!!\n"));
				GlobalFree( pBuffer );
				SUP64_Usb_Close( hWinUSBHandle );
				return  false;
			}
			else
			{
				//	ްײĐ
				EdTime = timeGetTime();
				_tprintf( _T(" Successfully!!\n"));
				_tprintf( _T("Transfer time = %ldms\n"), EdTime - StTime );
				_tprintf( _T("Transfer rate = %3.2fMB/s\n"), ( float )WriteNum / (( EdTime - StTime ) * 1000l ));
				GlobalFree( pBuffer );
			}
		}
	}	//	-------------------------------------------------------------------
	_tprintf( _T("\n"));
	#endif

	#if MEMR_TEST
	//	-----------------------------------------------------------------------
	//	ذޏ
	_tprintf( _T("MR Transfer Size %ldBytes\n"), ReadNum );

	//	ޯ̧m
    pBuffer = GlobalAlloc( GPTR, ReadNum );
	if( pBuffer == NULL )
	{
        CloseHandle( fp );
		SUP64_Usb_Close( hWinUSBHandle );
		_tprintf( _T("Memory Alloc ERROR!!\n"));
		return false;
	}

	_tprintf( _T("Memreading ........ "));
	StTime = timeGetTime();						//	̎Ԃް]ԂƂ
	if( !SUP64_Data_Read( hWinUSBHandle, SUP64_RANGE_8BIT, ReadNum, pBuffer ))
	{
		//	ذގs
		_tprintf( _T(" Failed!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		GlobalFree( pBuffer );
		return  false;
	}
	else
	{
		//	ذސ
		//	̧ٵ
        fp = CreateFile( L".\\bin\\Read.bin", GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL );
   		if( fp == NULL || fp == INVALID_HANDLE_VALUE )
		{
			_tprintf( _T(" File Open ERORR!!\n"));
			SUP64_Usb_Close( hWinUSBHandle );
            GlobalFree( pBuffer );
           	return false;
		}
		else
		{
			//	ޯ̧̧ق֏
    		WriteFile( fp, pBuffer, ReadNum, &rb, NULL );

			//	̧ٸ۰
			CloseHandle( fp );

			//	ޯ̧
			GlobalFree( pBuffer );

			//  ފmF
			if( ReadNum != rb )
			{
				_tprintf( _T(" File Size ERORR!!\n"));
				SUP64_Usb_Close( hWinUSBHandle );
				GlobalFree( pBuffer );
	           	return false;
			}

			//	ذސ
			EdTime = GetTickCount();
			_tprintf( _T(" Successfully!!\n"));
			_tprintf( _T("Transfer time = %ldms\n"), EdTime - StTime );
			_tprintf( _T("Transfer rate = %3.2fMB/s\n"), ( float )ReadNum / (( EdTime - StTime ) * 1000l ));
		}
	}
	//	-----------------------------------------------------------------------
	_tprintf( _T("\n"));
	#endif



	#if REG_TEST
	Wd = 0x0000000000000001;
	for(j=0;j<2;++j)
	{
		for(i=0;i<64;++i)
		{
			//	-----------------------------------------------------------------------
			//	ڼ޽ײď
			//	64bitڼ޽ɑ΂čsB
			_tprintf( _T("Write %016I64xh ........ "), Wd );
			if( !SUP64_Reg_Write( hWinUSBHandle, 16380, SUP64_RANGE_64BIT, Wd ))
			{
				//	ײĎs
				_tprintf( _T("Failed!!\n"));
				SUP64_Usb_Close( hWinUSBHandle );
				return false;
			}

			//	-----------------------------------------------------------------------
			//	ذޏ
			//	ڼ޽ײĂ64ޯڼ޽ذޯ
			if( SUP64_Reg_Read( hWinUSBHandle, 16380, SUP64_RANGE_64BIT, &Rd ))
			{
				//	ذސ
				_tprintf( _T("Read %016I64Xh"), Rd );
			}
			else
			{
				//	ذގs
				_tprintf( _T("Failed!!\n"));
				SUP64_Usb_Close( hWinUSBHandle );
				return	false;
			}

			//	r
			if( Wd == Rd )
			{
				_tprintf( _T(" Successfully!!\n"));
			}
			else
			{
				_tprintf( _T(" Failed!!\n"));
				SUP64_Usb_Close( hWinUSBHandle );
				return	false;
			}

			if( j == 0 )
			{
				Wd = ( Wd << 1 );
			}
			else
			{
				Wd = ( Wd << 1 ) | 1;
			}
		}
		Wd = 0xFFFFFFFFFFFFFFFE;
	}
	#endif

	#if I2C_TEST

    srand(( unsigned int )time( NULL ));
	for(k=0;k<128;++k)
	{
		I2c_Wd = rand() % 256;
		if( !SUP64_I2c_Write(  hWinUSBHandle, 0xA0, k, I2c_Wd ))
		{
			_tprintf( _T("I2C Write Failed!!\n"));
			SUP64_Usb_Close( hWinUSBHandle );
			return false;
		}
		else
		{
			wdump[k] = I2c_Wd;
		}

		//	EEPROMײđҋ@
		Sleep( 5 );
	}

	_tprintf( _T("I2C DUMP:\n"));
	for(k=0;k<128;++k)
	{
		if( !SUP64_I2c_Read(  hWinUSBHandle, 0xA0, k, &I2c_Rd ))
		{
			_tprintf( _T("I2C Read Failed!!\n"));
			SUP64_Usb_Close( hWinUSBHandle );
			return false;
		}
		else
		{
			rdump[k] = I2c_Rd;
		}
	}

	_tprintf( _T("ADRS 00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F\n"));
	for(k=0;k<8;++k)
	{
		_tprintf( _T("%04X "), k*16 );
		for(l=0;l<16;++l)
		{
			_tprintf( _T("%02X "), rdump[k*16+l]);
		}
		_tprintf( _T("\n"));
	}

	for(k=0;k<128;++k)
	{
		if( wdump[k] != rdump[k] )
		{
			_tprintf( _T("I2C Verify  Failed!!\n"));
			SUP64_Usb_Close( hWinUSBHandle );
			return false;
		}
	}
	_tprintf( _T("I2C Verify Successfully!!\n\n"));
	#endif


	#if TEMP_TEST
	for(n=0;n<4;++n)
	{
		if( !SUP64_Get_FPGA_Temp( hWinUSBHandle, 0, &Temp ))
		{
			_tprintf( _T("GET_TEMP() Failed!!\n"));
			SUP64_Usb_Close( hWinUSBHandle );
			return false;
		}
		_tprintf( _T("TEMP:%02d.%02d Celsius\n"), ( Temp & 0xFF00 ) >> 8, ( Temp & 0xFF ));
		Sleep( 500 );
	}
	#endif

	
	#if SUSPEND_TEST

	if( !SUP64_Suspend( hWinUSBHandle, 1 ))
	{
		_tprintf( _T("Suspend ON Failed!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		return false;
	}

	Sleep( 1000 );

	if( !SUP64_Suspend( hWinUSBHandle, 0 ))
	{
		_tprintf( _T("Suspend OFF Failed!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		return false;
	}
	_tprintf( _T("SUSPEND Successfully!!\n\n"));
	#endif
	
	#if GPIO_TEST

	if( !SUP64_GPIO_Dir( hWinUSBHandle, SUP64_GPIO_PORTC, SUP64_GPIO_DIROUT ))
	{
		_tprintf( _T("PORT Direction Failed!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		return false;
	}

	for(m=0;m<256;++m)
	{
		if( !SUP64_GPIO_Write( hWinUSBHandle, SUP64_GPIO_PORTC, m & 0xFF ))
		{
			_tprintf( _T("GPIO Write Failed!!\n"));
			SUP64_Usb_Close( hWinUSBHandle );
			return false;
		}

		if( !SUP64_GPIO_Read( hWinUSBHandle, SUP64_GPIO_PORTC, &GPIO_Rd ))
		{
			_tprintf( _T("GPIO Read Failed!!\n"));
			SUP64_Usb_Close( hWinUSBHandle );
			return false;
		}

		if( m != GPIO_Rd )
		{
			_tprintf( _T("GPIO Verify Error!!\n"));
			SUP64_Usb_Close( hWinUSBHandle );
			return false;
		}
	}
	_tprintf( _T("GPIO TEST  Successfully!!\n\n"));
	#endif

	
	#if WAVE_TEST

	if( !SUP64_GPIF_Set_Wave( hWinUSBHandle, SUP64_GPIFWAVE_DIR_READ, SUP64_GPIFWAVE_MODE_WORD ))
	{
		_tprintf( _T("GPIF WAVE SELECT Error!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		return false;
	}
	Sleep( 5 );

	if( !SUP64_GPIF_Set_Wave( hWinUSBHandle, SUP64_GPIFWAVE_DIR_READ, SUP64_GPIFWAVE_MODE_BURST ))
	{
		_tprintf( _T("GPIF WAVE SELECT Error!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		return false;
	}
	Sleep( 5 );

	if( !SUP64_GPIF_Set_Wave( hWinUSBHandle, SUP64_GPIFWAVE_DIR_WRITE, SUP64_GPIFWAVE_MODE_WORD ))
	{
		_tprintf( _T("GPIF WAVE SELECT Error!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		return false;
	}
	Sleep( 5 );

	if( !SUP64_GPIF_Set_Wave( hWinUSBHandle, SUP64_GPIFWAVE_DIR_WRITE, SUP64_GPIFWAVE_MODE_BURST ))
	{
		_tprintf( _T("GPIF WAVE SELECT Error!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		return false;
	}
	_tprintf( _T("GPIF WAVE SELECT Successfully!!\n\n"));

	#endif
	
	#if REGEX_TEST

	for(i=0;i<64;++i)
	{
		wd[i] = i;
	}

	//	ڼ޽ڽ964޲Ăײ
	if(	!SUP64_Reg_WriteEx( hWinUSBHandle, 9, 64, &wd[0] ))
	{
		_tprintf( _T("SUP64_RegWriteEx() Error!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		return false;
	}
	_tprintf( _T("SUP64_RegWriteEx() Successfully!!\n"));


	//	ڼ޽ڽ964޲Ăذ
	if(	!SUP64_Reg_ReadEx( hWinUSBHandle, 9, 64, &rd[0] ))
	{
		_tprintf( _T("SUP64_RegReadEx() Error!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		return false;
	}
	_tprintf( _T("SUP64_RegReadEx() Successfully!!\n\n"));


	for(i=0;i<64;++i)
	{
		if( wd[i] != rd[i] )
		{
			_tprintf( _T("REGEX VERIFY ERROR!!\n"));
			SUP64_Usb_Close( hWinUSBHandle );
			return false;
		}
		_tprintf( _T("WD:%02X,RD:%02X OK!!\n"), wd[i], rd[i] );
	}
	_tprintf( _T("SUP64_RegWriteEx/ReadEx() Successfully!!\n\n"));
	
	#endif



	#if REGWAIT_TEST

	if( !SUP64_GPIF_Reg_Wait( hWinUSBHandle, SUP64_GPIF_WAIT_REGREAD, 2 ))
	{
		//	ݒ莸s
		_tprintf( _T("SUP64_GPIF_Reg_Wait( READ ) Failed!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		return false;
	}
	_tprintf( _T("SUP64_GPIF_Reg_Wait( Read ) Successfully!!\n"));

	if( !SUP64_GPIF_Reg_Wait( hWinUSBHandle, SUP64_GPIF_WAIT_REGWRITE, 1 ))
	{
		//	ݒ莸s
		_tprintf( _T("SUP64_GPIF_Reg_Wait( WRITE ) Failed!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		return false;
	}
	_tprintf( _T("SUP64_GPIF_Reg_Wait( WRITE ) Successfully!!\n\n"));


	if( !SUP64_Reg_Write( hWinUSBHandle, 16160, SUP64_RANGE_64BIT, 0xc396815a12345678 ))
	{
		//	ײĎs
		_tprintf( _T("Failed!!\n"));
		SUP64_Usb_Close( hWinUSBHandle );
		return false;
	}

	#endif

	//	I
//	SUP64_Usb_Close( hWinUSBHandle );

	return 0;
}

